首页 > 代码库 > Leetcode: Max Points on a line
Leetcode: Max Points on a line
Given n points on a 2D plane, find the maximum number of points that lie on the same straight line.
Brute Force的做法,N个点两两可以构成N(N-1)/2条线,我们可以找这N(N-1)/2条线中线上点数最大值,只需对每一条线再进行一层O(N)的遍历,总共是O(N^3)。
用第二种方法更好,选一个基准点, 看后面每一个点跟它构成的直线, 维护一个HashMap, key是跟这个点构成直线的斜率的值, 而value就是该斜率对应的点的数量, 计算它的斜率, 如果已经存在, 那么就多添加一个点, 否则创建新的key。 这里只需要考虑斜率而不用考虑截距是因为所有点都是对应于一个参考点构成的直线, 只要斜率相同就必然在同一直线上。 最后取map中最大的值, 就是通过这个点的所有直线上最多的点的数量。 对于每一个点都做一次这种计算, 并且后面的点不需要看扫描过的点的情况了, 因为如果这条直线是包含最多点的直线并且包含前面的点, 那么前面的点肯定统计过这条直线了。 因此算法总共需要两层循环, 外层进行点的迭代, 内层扫描剩下的点进行统计, 时间复杂度是O(n^2), 空间复杂度是哈希表的大小, 也就是O(n), 比起上一种做法用这里用哈希表空间省去了一个量级的时间复杂度。
1 /** 2 * Definition for a point. 3 * class Point { 4 * int x; 5 * int y; 6 * Point() { x = 0; y = 0; } 7 * Point(int a, int b) { x = a; y = b; } 8 * } 9 */10 public class Solution {11 public int maxPoints(Point[] points) {12 if (points==null || points.length==0) return 0;13 int allTimeMax = 0;14 for (int i=0; i<points.length; i++) {15 HashMap<Double, Integer> map = new HashMap<Double, Integer>();16 double ratio = 0.0;17 int sameNum = 0;18 int localMax = 1;19 for (int j=i+1; j<points.length; j++) {20 if (points[j].x == points[i].x && points[j].y == points[i].y) {21 sameNum++;22 continue;23 }24 else if (points[j].x == points[i].x) {25 ratio = (double)Integer.MAX_VALUE;26 }27 else if (points[j].y == points[i].y) {28 ratio = 0.0;29 }30 else {31 ratio = (double)(points[j].y - points[i].y) / (double)(points[j].x - points[i].x);32 }33 if (map.containsKey(ratio)) {34 map.put(ratio, map.get(ratio)+1);35 }36 else {37 map.put(ratio, 2);38 }39 }40 for (int value : map.values()) {41 localMax = Math.max(localMax, value);42 }43 localMax = localMax + sameNum;44 allTimeMax = Math.max(allTimeMax, localMax);45 }46 return allTimeMax;47 }48 }
Leetcode: Max Points on a line
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。